// oAL

#include <windows.h>

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>	 // file streams
#include <string>


#include <al/al.h>
#include <al/alc.h>
#include <al/alu.h>
#include <al/alut.h>



using namespace std;

#include "oAL.h"




int o2_SoundE = 0; //-     
int Glob_klvSndKan = 0;

t_zvu_Sbor  zvu1; //extern in _main.cpp




ALCdevice* pDevice =0;
ALCcontext* pContext =0;


BYTE DefaultWAV[8] = {0,0,0,0,0,0,0,0}; // :)




#define closeRetZero() {if(frs.is_open()) frs.close(); return 0;}

#define ERRMSG(Msg) MessageBox(NULL, Msg, "Error", MB_OK | MB_ICONEXCLAMATION)
//#define ERRMSG2(Msg, nom) MessageBox(NULL, Msg, nom, MB_OK | MB_ICONEXCLAMATION)







int NotSound()
{
	if( ! o2_SoundE ) return 1;
	if(alGetError() != AL_NO_ERROR) return 1;
	return 0; // ok
}



int CheckALCError()
{
	ALenum ErrCode;
	std::string Err = "ALC error: ";
	if( (ErrCode = alcGetError(pDevice)) != ALC_NO_ERROR )
	{
		Err += (char*)alcGetString(pDevice, ErrCode);
		ERRMSG(Err.data());
		return 0;
	}
	return 1;
}


/*
char CheckALErr32ch[32];
ALboolean CheckALError(int entPN=0)
{
	memset( CheckALErr32ch, 0, 32);
	if(entPN)
		sprintf( CheckALErr32ch, "Error (in p%d)", entPN);
	else sprintf( CheckALErr32ch, "Error (...)");

	ALenum ErrCode;
	string Err = "OpenAL error: ";
	if ((ErrCode = alGetError()) != AL_NO_ERROR)
	{
		Err += (char *)alGetString(ErrCode);
		ERRMSG2(Err.data(), CheckALErr32ch);
		return AL_FALSE;
	}
	return AL_TRUE;
}
*/



int InitializeOpenAL()
{
	ALfloat Pos[] = {0.f, 0.f, 0.f};//{0.f, 0.f, 0.f};
	ALfloat Vel[] = {0.f, 0.f, 0.f};//{0.f, 0.f, 0.f};

	// Orientation of the Listener. (first 3 elements are "at", second 3 are "up")
	// Also note that these should be units of '1'.
	ALfloat Ori[] = {0.f, 0.f, -1.f,  0.f, 1.f, 0.f};


	//pDevice = alcOpenDevice(NULL);
	pDevice = alcOpenDevice( (ALCubyte*)"DirectSound3D" );

	if( ! pDevice )
	{
		ERRMSG("DirectSound3D  sound device not present");
		return false;
	}

	pContext = alcCreateContext(pDevice, NULL);
	if( ! CheckALCError() )
	{
		alcCloseDevice(pDevice); pDevice=0; pContext=0;
		return 0;
	}

	alcMakeContextCurrent(pContext);

	if( alcGetError(pDevice) != ALC_NO_ERROR )
	{
		alcMakeContextCurrent(NULL);
		if(pContext) alcDestroyContext(pContext);
		if(pDevice) alcCloseDevice(pDevice);
		pContext=0;
		pDevice=0;
		return 0;
	}

    alListenerfv(AL_POSITION,  Pos);
    alListenerfv(AL_VELOCITY,  Vel);
    alListenerfv(AL_ORIENTATION, Ori);
	return 1;
}









void DestroyOpenAL()
{
	// Clear all buffers and sources
	//------

	alcMakeContextCurrent(NULL);// Shut down context
	if(pContext) alcDestroyContext(pContext);// Destroy context
	if(pDevice) alcCloseDevice(pDevice);// Close sound device
	pContext=0;
	pDevice=0;
}








int OpenAL_SrcKanKlv()
{
	ALuint src128[128];			int kans = 0;  int i;

	for( i=0; i<128; i++)
	{
		alGenSources(1, &(src128[i]) );
		if(alGetError() != AL_NO_ERROR) { kans = i; break; }
	}

	for(i=0; i<kans; i++) {  if( alIsSource(src128[i]) ) alDeleteSources(1, &(src128[i]));  }

	return kans;
}






int InitOpenAL()
{
	if( ! InitializeOpenAL() ) return 0;

	Glob_klvSndKan = OpenAL_SrcKanKlv();

	alGetError(); // Clear the bit.

	alListenerf(AL_GAIN, 0.9f);
	alDopplerFactor(1.0);
	alDopplerVelocity(343);

	return 1;
}



void ExitOpenAL()
{
	DestroyOpenAL();
}












// ============



void t_zvu_Sbor::sbros()
{
		for(int i=0; i < t_zvu_Sbor_Last+1; i++)
		{
			if( zm[i] )
			{
				if( alIsBuffer(zm[i]) ) alDeleteBuffers( 1, &(zm[i]) );
			}
			zm[i] = 0;
		}
		now=1;
}



int t_zvu_Sbor::ok(int nom)
{
	if( nom < 1 || nom > t_zvu_Sbor_Last ) return 0;
	if( alIsBuffer(zm[nom]) ) return 1;
	return 0;
}











extern int streamGetToZ1310( std::ifstream& frs );

extern std::string TextTrimS(const std::string& s);


char* getWaveFile16_22kiloMono(std::string s, int& sizeFile)
{
    sizeFile = 0;
	FILE* f = fopen( s.c_str(), "rb");	if(!f) return 0; //   

	int size;
		fseek(f, 0, SEEK_END);  size = ftell(f);  fseek(f, 0, SEEK_SET); //  
		sizeFile = size;
		if(size < 1) {fclose(f); return 0;}

		char*  bData = 0;
		bData = (char*)malloc(size);  if(!bData) {fclose(f); return 0;}

		fread( bData, size, 1, f);  fclose(f); //  -.
 return bData;
}


int t_zvu_Sbor::LoadPackWAV(std::string sborName)
{
	//int SpeMemCount=0;

ALenum format;
ALsizei size;
//ALvoid* data;
char* pereData=0;
ALsizei freq;
ALboolean loop;

int sizeFile;

	int i, adr2, klv;//, mips;
	std::ifstream frs;
	std::string s1 = "";
	FILE* fz=0;


	frs.open( sborName.c_str() );	if( ! frs.is_open() ) return 0;



	getline(frs, s1); //  


	frs >> klv;		//  (     )
		streamGetToZ1310( frs );// 
	if( klv > t_zvu_Sbor_Last+1) klv = t_zvu_Sbor_Last+1;


	for(i=0; i < klv; i++) // -------------------------
	{
		frs >> adr2; //       ..
			streamGetToZ1310( frs );//   
		if( adr2 < 0) adr2 = 0;
		if( adr2 > t_zvu_Sbor_Last ) adr2 = t_zvu_Sbor_Last;

		//..     
		//if( alIsBuffer(zm[adr2]) ) closeRetZero(); //   
		if( zm[adr2] != 0) //16777216 ) //   -
            closeRetZero();

		getline(frs, s1); // 
			if ( frs.fail() ) closeRetZero();


		alGenBuffers( 1, &(zm[adr2]) );
		if(alGetError() != AL_NO_ERROR) closeRetZero();//(..  -)


		s1 = TextTrimS(s1);

			//if( Ext_Like(s1, "ogg") )
			//{
			//	if( ! tmpSnd.LoadOggZvuMono16( s1, &(zm[adr2]) ) )
			//	{ if( alIsBuffer(zm[adr2]) ) alDeleteBuffers( 1, &(zm[adr2]) );
			//		zm[adr2] = 0;
			//	}
			//	tmpSnd.Close();//   .
			//}
			//else if( Ext_Like(s1, "wav") )
			//{
				//alutLoadWAVFile( (ALbyte*)s1.data(), &format, &data, &size, &freq, &loop);
				//alBufferData( zm[adr2], format, data, size, freq);
				//alutUnloadWAV(format, data, size, freq);
				pereData = getWaveFile16_22kiloMono( s1, sizeFile);
				if(pereData)
				{
                    //sizeWaveData_int = *( (int*)&(pereData[40]) );//    
                    //    (sizeFile-44)
					alBufferData( zm[adr2], AL_FORMAT_MONO16,
				 		&(pereData[44]), sizeFile-44, 22050);
					free(pereData); pereData=0;
					// - ,      16188 
				}

			//}


		//SpeMemCount += zm[adr2].GetMemByteSize();

		getline(frs, s1);// 
	}//for

frs.close();


if(alGetError() != AL_NO_ERROR) return 0;

now = adr2 + 1;
return 1;
}





















//int ZSrc_KillSrc(ALuint* Source)

void t_zSrc::sbros()
{
	//if( NotSound() ) return 0; // ???
	if( !s ) return;
	if( ! alIsSource(s)) {s=0; return;}

int st;
	alGetSourcei( s, AL_SOURCE_STATE, &st);
		switch(st)
		{
		case AL_PLAYING:
		case AL_PAUSED:
			//ns_Zvuk::NowSrcPlayKlv -= 1; //    .
			alSourceStop(s);
		break;

		case AL_STOPPED:
		default: //AL_INITIAL:
		break;
		}
	alDeleteSources(1, &s);	s=0;

	//ns_Zvuk::NowSrcUseKlv -= 1;
}








//int ZSrc_GetCreate(ALuint* Source)

int t_zSrc::getCrt()
{
	if( NotSound() ) return 0;

	sbros();

	alGenSources(1, &s);
	if(alGetError() != AL_NO_ERROR) {s=0; return 0;}

	float pos[3] = {0.f, 0.f, 0.f};
	//alSourcei (s, AL_BUFFER,   zvu1.zm[1]);
	alSourcef (s, AL_PITCH,    1.f );
	alSourcef (s, AL_GAIN,     1.f  );
	alSourcefv(s, AL_POSITION, pos );
	alSourcefv(s, AL_VELOCITY, pos );
	alSourcei (s, AL_LOOPING,  0 );

	//ns_Zvuk::NowSrcUseKlv += 1; //  
	return 1;
}







	// ZSrc_SetBuf( ZSrcHero[0],  0,1);
//void ZSrc_SetBuf(ALuint srcAL, int gru, int buf)
//void ZSrc_SetBuf(ALuint srcAL, int buf)

void t_zSrc::setZvu(int buf)
{
	if( NotSound() ) return;

	if(!s) getCrt();
	if( ! alIsSource(s) ) return;

	if( zvu1.ok(buf) )//alIsBuffer
	{	alSourcei( s, AL_BUFFER, zvu1.zm[buf] );
	}
}







void t_zSrc::Relative(int set)
{
	if( ! alIsSource(s) ) return;
	if(set)	alSourcei( s, AL_SOURCE_RELATIVE, AL_TRUE);
	else	alSourcei( s, AL_SOURCE_RELATIVE, AL_FALSE);
}


void t_zSrc::RoRef( float RoLL, float ReferDist)
{
	if( ! alIsSource(s) ) return;

	alSourcef( s, AL_ROLLOFF_FACTOR, RoLL); //def 1.0
	alSourcef( s, AL_REFERENCE_DISTANCE, ReferDist);
}








void t_zSrc::Pitch(float setPitch)
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;

	alSourcef( s, AL_PITCH,   setPitch );
}

void t_zSrc::Gain(float setGain)
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;

	alSourcef( s, AL_GAIN,   setGain );
}

void t_zSrc::Loop(int setLoop)
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;

	alSourcei ( s, AL_LOOPING, setLoop );
}





void t_zSrc::Pos(float floX, float floY, float floZ)
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;

	float pos[3] = {floX, floY, floZ};
	alSourcefv( s, AL_POSITION, pos );
}

//void ZSrc_PosV(ALuint srcAL, vec3 v)
//{
//	if( NotSound() ) return;
//	if( alIsSource( srcAL ) == 0 ) return;
//
//	alSourcefv(srcAL, AL_POSITION, &v.x );
//}







void t_zSrc::Vel(float floX, float floY, float floZ)
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;

	float velo[3] = {floX, floY, floZ};
	alSourcefv( s, AL_VELOCITY, velo );
}

//void ZSrc_VelV(ALuint srcAL, vec3 v)
//{
//	if( NotSound() ) return;
//	if( alIsSource( srcAL ) == 0 ) return;
//
//	alSourcefv(srcAL, AL_VELOCITY, &v.x );
//}








	// 0=  -.,  1= .,  2= .,  3=  .,  4= 
int t_zSrc::State()
{
	if( NotSound() ) return 0; if( ! alIsSource(s) ) return 0;

int st;
	alGetSourcei( s, AL_SOURCE_STATE, &st);
	switch(st)
	{
	case AL_PLAYING:		return 2;
	case AL_PAUSED:			return 3;
	case AL_STOPPED:		return 4;
	default: //AL_INITIAL:
			return 1;
	}
return 0;
}




int t_zSrc::isPlaying()
{
	if( State() == 2 ) return 1;
return 0;
}




//void ZSrc_Reset(ALuint srcAL)
void t_zSrc::Reset()
{
	if( NotSound() ) return; if( ! alIsSource(s) ) return;
	static float pos[3] = {0.f,0.f,0.f};

	alSourcef (s, AL_GAIN,    0.f);
	alSourcei (s, AL_LOOPING, 0);
	alSourceStop( s );
	alSourcef (s, AL_PITCH,   1.f);
	alSourcef (s, AL_GAIN,    1.f);
	//alSourcefv(s, AL_POSITION, pos);
	alSourcefv(s, AL_VELOCITY, pos);
}








inline float Rand2F_( float mini=0.0f, float maxi=1.0f, int dolei=100)
{
return  float( rand() % dolei + 1)  *  ((maxi - mini) / float(dolei))  + mini;
}

//void ZSrcResetStart( ALuint anSrc, int znom, int loopFlag=0, float zGain=0.9f,
//					float zPitMin=0.8f, float zPitMax=1.f, int zPitDoli=10)

void t_zSrc::ReStart( int zvuNom, int loopFlag, float zGain,
					float zPitMin, float zPitMax, int zPitDoli)
{
    if( NotSound() ) return; if( ! alIsSource(s) ) return;
	Reset(); //    
	setZvu( zvuNom);
	Loop( loopFlag);
	Gain( zGain);
	if(zPitDoli > 0) Pitch( Rand2F_( zPitMin, zPitMax, zPitDoli) );
	else Pitch( zPitMin );
	alSourcePlay(  s ); // .
}






int t_zSrc::PlayPro1( int flagZvuE)
{
	if( flagZvuE )
	{
		if( ! isPlaying() )
		{
			if( alIsSource(s) )
			{
				alSourceRewind(s);
				alSourcePlay(s);
				return 1;
			}
		}
	}
return 0;
}











//		alSourceStop(   ZSrcChain[1] );

//		alSourcePlayv( ZSrcMainKot_Last+1, ZSrcMainKot ); //      ...






//void SetListenerV(vec3 pos, vec3 velos, vec3 look_at, vec3 up)
//{
//float orient[6];
//	orient[0] = look_at.x;	orient[1] = look_at.y;	orient[2] = look_at.z;
//	orient[3] = up.x;	orient[4] = up.y;	orient[5] = up.z;
//
//	alListenerfv(AL_POSITION,    &pos.x);
//	alListenerfv(AL_VELOCITY,    &velos.x);
//	alListenerfv(AL_ORIENTATION, orient);
//}




void SetListenerToZero()
{
	static float pos[3] = {0.f,0.f,0.f};
	static float orient[6] = {0.f,0.f,-1.f,   0.f,1.f,0.f};
	alListenerfv(AL_POSITION,    pos);
	alListenerfv(AL_VELOCITY,    pos);
	alListenerfv(AL_ORIENTATION, orient);
}







